class Oslo < Formula
  desc "CLI tool for the OpenSLO spec"
  homepage "https://openslo.com/"
  url "https://github.com/OpenSLO/oslo/archive/refs/tags/v0.12.0.tar.gz"
  sha256 "d76baf57820b896a648b720e387bb6f8c6137bc05f888a3b1e0e2029827cd607"
  license "Apache-2.0"
  head "https://github.com/openslo/oslo.git", branch: "main"

  depends_on "go" => :build

  def install
    ldflags = "-s -w -X main.Version=#{version}"
    system "go", "build", *std_go_args(ldflags: ldflags), "./cmd/oslo"

    generate_completions_from_executable(bin/"oslo", "completion")

    pkgshare.install "examples"
  end

  test do
    test_file = pkgshare/"examples/definitions/slo.yaml"
    assert_match "Valid!", shell_output("#{bin}/oslo validate -f #{test_file}")

    output = shell_output("#{bin}/oslo convert -f #{test_file} -o nobl9 2>&1", 1)
    assert_match "the convert command is only supported for apiVersion 'openslo/v1'", output
  end
end
